
/**
 * This variable holds the information, which button (on top) is active
 * The interaction with the plot changes in respect to this variable (e.g. time-chaning or position changing) 
*/
var mouseMode = "move"; //values: move, time, select

/**
 * This is an jquery ui method.
 * It init the contextmenu of the plot 
 * (addAxis, vanishingpoint, scatterplot)
*/
$("#rects").contextmenu({
    delegate: ".hasmenu",
    menu: [
        {title: "Add Axis", cmd: "addAxis", uiIcon: "ui-icon-circle-plus", children: [
            {title: "avg_rss12", cmd: "avg_rss12",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "var_rss12", cmd: "var_rss12",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "avg_rss13", cmd: "avg_rss13",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "var_rss13", cmd: "var_rss13",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "avg_rss23", cmd: "avg_rss23",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "var_rss23", cmd: "var_rss23",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            },
            {title: "type", cmd: "type",
                action:function(event,ui){
                    addAxis(ui.cmd,ui.target[0].getAttribute("axesId"));}
            }
        ]
        },
        {title: "Open Vanishing Point", cmd: "vpoint",
            action:function(event,ui){
                addVanishingPoint(ui.target[0].getAttribute("axesId"));}
        },
        {title: "Create ScatterPlot", cmd: "scatterPlot",
            action:function(event,ui){
                addScatterPlotFromGUI(ui.target[0].getAttribute("axesId"))
            }
        }
    ]
});

/**
 * This is an jquery ui method.
 * It init the contextmenu of the axis 
 * (removeAxis, vanishingpoint, timeseriesplot)
*/
$("#axesDescription").contextmenu({
    delegate: ".axis",
    menu: [
        {title: "Remove Axis", cmd: "removeAxis", uiIcon: "ui-icon-circle-minus",
            action:function(event,ui){
                moveNodeFunctionCall(removeAxis,ui);
            }
        },
        {title: "Open Single Vanishing Point", cmd: "svpoint", children: [
            {title: "no vanishingpoint", cmd: "0",
                action:function(event,ui){
                    moveNodeFunctionCall(setVanishingPointForAxisWithId,ui);
                }
            },
            {title: "vanishingpoint to right", cmd: "1",
                action:function(event,ui){
                    moveNodeFunctionCall(setVanishingPointForAxisWithId,ui);
                }
            },
            {title: "vanishingpoint to left", cmd: "2",
                action:function(event,ui){
                    moveNodeFunctionCall(setVanishingPointForAxisWithId,ui);
                }
            }
        ]
        },
         {title: "Create Time Series", cmd: "timeSeries",
            action:function(event,ui){
                moveNodeFunctionCall(addTimeSeries,ui);
            }
        }
    ]
});

/**
 * This is an jquery ui method.
 * It init the close action of the "other plots" (on bottom container)
*/
$("#overflowing").contextmenu({
    delegate: ".container",
    menu: [
        {title: "Close", cmd: "close" ,uiIcon: "ui-icon-circle-close",
            action:function(event,ui){
                removePlot(ui.target[0].id);
            }
        }
    ]
});

// Helper Function
function moveNodeFunctionCall(callbackFunction,ui){
    if(mouseMode === "select") {
        alert("this action is only in mode: move, time possible!"); 
        onClickMoveTool();
        return;
    }
    removeAllBrushes();
    var tNode = ui.target[0];
    while(tNode) {
        if(tNode.getAttribute("axesId") != undefined) {
            callbackFunction(tNode.getAttribute("axesId"), ui.cmd);
            break;
        }
        tNode = ui.target[0].parentNode;
    }
}

/**
 * This is an jquery ui method.
 * This inits the timeslider on top of the application.
 * This slider is responsible for the extent of the time, which is navigatable. The Timeseriesplots also depends on that range.
*/
$( "#global-time-slider" ).slider({
    range: true,
    step: 250,
    min: 0,
    max: 119750,
    values: [ 1000, 10000 ],
    slide: function( event, ui ) {
        $( "#time-slider" ).val(ui.values[ 0 ] + " - "+ ui.values[ 1 ]);
        updatePlotDimensions();
    }
});
$( "#time-slider" ).val($( "#global-time-slider" ).slider( "values", 0 ) +
    " - " + $( "#global-time-slider" ).slider( "values", 1 ) );

/**
 * This is an jquery ui method.
 * The init of the resize action of the container and the other plots
*/
$( ".container" ).resizable().draggable({ scroll: true, containment: "parent" });

$("#contant").resizable({
    resize: function(event, ui) {
        ui.size.width = ui.originalSize.width;
        updatePlotDimensions();
    }
});

/**
 * This method is triggered, when the move-tool is selected.
 * It change the: rect, axis, and background
 * rect: move the whole plot, axis: moves the axis, removes brushes on axis
*/
function onClickMoveTool() {
    //svgFrame.call(dragShift);
    //svgFrame.on('mousedown.drag', null);
    d3.select("#backgroundforclicking").on('mousedown.drag', null);
    d3.select("#backgroundforclicking").call(dragShift);
    for(var i = 0; i < _AXES.length; i++) {
        _AXES[i].axisElement.on('mousedown.drag', null);
        _AXES[i].axisElement.call(dragPosition);
        try {
            _AXES[i].rect.on('mousedown.drag', null);
            _AXES[i].rect.call(dragShift);
        } catch (ex){}
    }
    removeAllBrushes();
    $("#select-Button").removeClass("selectedButton");
    $("#move-Button").addClass("selectedButton");
    $("#time-Button").removeClass("selectedButton");
    mouseMode = "move";
}

/**
 * This method is triggered, when the time-tool is selected.
 * It change the: rect, axis, and background
 * rect: moves the adjezent axis in time, axis: moves the axis in time, background: no interaction
*/
function onClickTimeTool() {
    d3.select("#backgroundforclicking").on('mousedown.drag', null);
    //svgFrame.on('mousedown.drag', null);
    for(var i = 0; i < _AXES.length; i++) {
        _AXES[i].axisElement.on('mousedown.drag', null);
        _AXES[i].axisElement.call(dragTime);
        try {
            _AXES[i].rect.on('mousedown.drag', null);
            _AXES[i].rect.call(dragTimeArea);
        } catch (ex){}
    }
    removeAllBrushes();
    $("#select-Button").removeClass("selectedButton");
    $("#move-Button").removeClass("selectedButton");
    $("#time-Button").addClass("selectedButton");
    mouseMode = "time";


}

/**
 * This method is triggered, when the time-tool is selected.
 * It change the: rect, axis, and background
 * rect: no interaction, axis: brush interaction, background: no interaction
*/
function onClickSelectTool() {
    //svgFrame.on('mousedown.drag', null);
    d3.select("#backgroundforclicking").on('mousedown.drag', null);
    for(var i = 0; i < _AXES.length; i++) {
        _AXES[i].axisElement.on('mousedown.drag', null);
        try {
            _AXES[i].rect.on('mousedown.drag', null);
        } catch (ex){}
    }
    removeAllBrushes();
    resetAllBrushes();
    $("#select-Button").addClass("selectedButton");
    $("#move-Button").removeClass("selectedButton");
    $("#time-Button").removeClass("selectedButton");
    mouseMode = "select";
}

/**
 * Helper function
 * remove all brushes
*/
function removeAllBrushes() {
    var brushDeletion = $(".brush");
    brushDeletion.remove();
}

/**
 * Helper function
 * append new brush structure
*/
function resetAllBrushes() {
    for(var i = 0; i < _AXES.length; i++) {

        _AXES[i].brushElement = _AXES[i].axisElement.append("g")
            .attr("class","brush")
            .call(_AXES[i].brush);

        _AXES[i].brushElement.selectAll("rect")
            .attr("x", -10)
            .attr("width", 16);
    }
}