/**
 * this is temporal variable for storing all dataset paths
 * @type {[*]}
 */
var fileURLs = [
    "dataset/bending1/dataset1.csv",
    "dataset/bending1/dataset2.csv",
    "dataset/bending1/dataset3.csv",
    "dataset/bending1/dataset4.csv",
    "dataset/bending1/dataset5.csv",
    "dataset/bending1/dataset6.csv",
    "dataset/bending1/dataset7.csv",
    "dataset/bending2/dataset1.csv",
    "dataset/bending2/dataset2.csv",
    "dataset/bending2/dataset3.csv",
    "dataset/bending2/dataset4.csv",
    "dataset/bending2/dataset5.csv",
    "dataset/bending2/dataset6.csv",
    "dataset/cycling/dataset1.csv",
    "dataset/cycling/dataset2.csv",
    "dataset/cycling/dataset3.csv",
    "dataset/cycling/dataset4.csv",
    "dataset/cycling/dataset5.csv",
    "dataset/cycling/dataset6.csv",
    "dataset/cycling/dataset7.csv",
    "dataset/cycling/dataset8.csv",
    "dataset/cycling/dataset9.csv",
    "dataset/cycling/dataset10.csv",
    "dataset/cycling/dataset11.csv",
    "dataset/cycling/dataset12.csv",
    "dataset/cycling/dataset13.csv",
    "dataset/cycling/dataset14.csv",
    "dataset/cycling/dataset15.csv",
    "dataset/lying/dataset1.csv",
    "dataset/lying/dataset2.csv",
    "dataset/lying/dataset3.csv",
    "dataset/lying/dataset4.csv",
    "dataset/lying/dataset5.csv",
    "dataset/lying/dataset6.csv",
    "dataset/lying/dataset7.csv",
    "dataset/lying/dataset8.csv",
    "dataset/lying/dataset9.csv",
    "dataset/lying/dataset10.csv",
    "dataset/lying/dataset11.csv",
    "dataset/lying/dataset12.csv",
    "dataset/lying/dataset13.csv",
    "dataset/lying/dataset14.csv",
    "dataset/lying/dataset15.csv",
    "dataset/sitting/dataset1.csv",
    "dataset/sitting/dataset2.csv",
    "dataset/sitting/dataset3.csv",
    "dataset/sitting/dataset4.csv",
    "dataset/sitting/dataset5.csv",
    "dataset/sitting/dataset6.csv",
    "dataset/sitting/dataset7.csv",
    "dataset/sitting/dataset8.csv",
    "dataset/sitting/dataset9.csv",
    "dataset/sitting/dataset10.csv",
    "dataset/sitting/dataset11.csv",
    "dataset/sitting/dataset12.csv",
    "dataset/sitting/dataset13.csv",
    "dataset/sitting/dataset14.csv",
    "dataset/sitting/dataset15.csv",
    "dataset/standing/dataset1.csv",
    "dataset/standing/dataset2.csv",
    "dataset/standing/dataset3.csv",
    "dataset/standing/dataset4.csv",
    "dataset/standing/dataset5.csv",
    "dataset/standing/dataset6.csv",
    "dataset/standing/dataset7.csv",
    "dataset/standing/dataset8.csv",
    "dataset/standing/dataset9.csv",
    "dataset/standing/dataset10.csv",
    "dataset/standing/dataset11.csv",
    "dataset/standing/dataset12.csv",
    "dataset/standing/dataset13.csv",
    "dataset/standing/dataset14.csv",
    "dataset/standing/dataset15.csv",
    "dataset/walking/dataset1.csv",
    "dataset/walking/dataset2.csv",
    "dataset/walking/dataset3.csv",
    "dataset/walking/dataset4.csv",
    "dataset/walking/dataset5.csv",
    "dataset/walking/dataset6.csv",
    "dataset/walking/dataset7.csv",
    "dataset/walking/dataset8.csv",
    "dataset/walking/dataset9.csv",
    "dataset/walking/dataset10.csv",
    "dataset/walking/dataset11.csv",
    "dataset/walking/dataset12.csv",
    "dataset/walking/dataset13.csv",
    "dataset/walking/dataset14.csv",
    "dataset/walking/dataset15.csv"
];
var counter = 0;

function typeLoader(d) {

    for (var i in d) {
        if (!isNaN(d[i])) {
            d[i] = +d[i];
        }
    }
    return d;
}

/**
 * This method inits the dataset. It also adds an attribute called "type", which is given by the path.
*/
function converter(data) {

    for (var i = 0; i < data.length; i++) {
        data[i].type = fileURLs[counter].substr(8, (fileURLs[counter].indexOf("/dataset") - 8));
        data[i].index = counter;
    }

    _DATASET.push(data);
    counter++;
    if (counter < fileURLs.length)
        loading(counter);
    else
        init();
}

/**
 * loading the dataset with the index "index". 
*/
function loading(index) {
    d3.csv(fileURLs[index], typeLoader, converter);
}

/**
 * this method is the first initial method. It reads the dataset and stores it into the dataset variable.
 * It calls as callback the init() method.
 */
function loadDataset() {
    loading(0);
}

